/*******************************************************************\
*	file: 		XCMDUtils.h											*
*	version:	1.06 												*
* 																	*
* Header file for XCMDutils.c (quod vide)							*
* -----------------------------------------------------------------	*
* By:	Greg Kimberly, Donald Koscheka								*
* Date:	21-Sept-87													*
* 	Copyright 1987, 1988 Apple Computer, Inc.						*
* All Rights Reserved												*
*																	*
* -----------------------------------------------------------------	*
*						Modification History						*
* -----------------------------------------------------------------	*
*  Date	   	| By	|	 				Description					*
* -----------------------------------------------------------------	*
* 21-Sep-87	| GK	| file created									*
* 13-Jan-88	| DK	| added resource id's for atp, nbp and adsp 	*
*			|		| control blocks.								*
* -----------------------------------------------------------------	*
\*******************************************************************/


#define 	GLOBALATPDATA 			7394
#define		GLOBALNBPDATA			28400
#define		GLOBALDSPDATA			29337
#define		GLOBALSKTDATA			21644

#define		EntityNameStr			-16096		/*** node name from the chooser ***/
#define		EntityTypeStr			18526
#define		EntityZoneStr			16897
#define		myEntityNameStr			13913
#define 	true 					1
#define 	false 					0
#define		DEFAULT_ERROR			23220
#define		NO_ERROR				22476
#define		MEM_ERROR				31830

#include 	<Errors.h>

pascal	void	Debugger()	extern 0xA9FF;   
void 			pStrCopy();
void 			SaveHandle();
long 			RetrieveHandle();
short 			slength();
short 			strcopy();
short 			sappend();
Handle 			ErrorReturn();
StringPtr		*glob();
short			strCMP();
char			**PacketToString();