UNIT PeekUnit;

INTERFACE
	USES
		XCmdIntf, XCmdUtils;

	PROCEDURE main (paramPtr : XCmdPtr);

IMPLEMENTATION

	PROCEDURE Peek (paramPtr : XCmdPtr);
		VAR
			peekAddr : Ptr;
			peekSize, peekVal : LongInt;
			str : Str255;
			tempWordPtr : ^integer;
			tempLongPtr : ^longint;
	BEGIN
		WITH paramPtr^ DO
			BEGIN
		{ first param is addr }
				ZeroToPas(paramPtr, params[1]^, str);
				peekAddr := ptr(StrToNum(paramPtr, str));

		{ second param, if given, is size }
				peekSize := 1;
				IF paramCount = 2 THEN
					BEGIN
						ZeroToPas(paramPtr, params[2]^, str);
						peekSize := StrToNum(paramPtr, str);
					END;

				CASE peekSize OF
					1 : 
						peekVal := BitAnd($000000FF, peekAddr^);
					2 : 
						BEGIN
							tempWordPtr := pointer(BitAnd($FFFFFFFE, ord4(peekAddr)));
							peekVal := BitAnd($0000FFFF, tempWordPtr^);
						END;
					4 : 
						BEGIN
							tempLongPtr := pointer(BitAnd($FFFFFFFE, peekAddr^));
							peekVal := tempLongPtr^;
						END;
					OTHERWISE
						peekVal := 0;
				END;

				str := NumToStr(paramPtr, peekVal);
				returnValue := PasToZero(paramPtr, str);
			END;
	END;

	PROCEDURE main;
	BEGIN
		Peek(paramPtr);
	END;

END.
