UNIT FlashUnit;
INTERFACE
	USES
		XCmdIntf, XCmdUtils;

	PROCEDURE main (paramPtr : XCmdPtr);

IMPLEMENTATION

	PROCEDURE Flash (paramPtr : XCmdPtr);
		VAR
			flashCount : LongInt;
			i : INTEGER;
			port : GrafPtr;
			str : Str255;

		PROCEDURE Fail (errMsg : Str255); { set theResult and quit }
		BEGIN
			paramPtr^.returnValue := PasToZero(paramPtr, errMsg);
		END;

	BEGIN
		IF paramPtr^.paramCount <> 1 THEN
			Fail('parameter count is not 1');

		ZeroToPas(paramPtr, paramPtr^.params[1]^, str);	{ first param is flash count }
		flashCount := StrToNum(paramPtr, str);

		IF ODD(flashCount) THEN
			Fail('can''t flash an odd number of times')
		ELSE
			BEGIN
				GetPort(port);
				FOR i := 1 TO flashCount DO
					BEGIN
						InvertRect(port^.portRect);
						InvertRect(port^.portRect);
					END;
			END
	END;

	PROCEDURE main;
	BEGIN
		Flash(paramPtr);
	END;

END.